pipx(1)

NAME
pipx - Install and execute apps from Python packages.

SYNOPSIS
pipx [-h] [--version] {install,inject,upgrade,upgrade-all,uninstall,uninstall-all,reinstall,reinstall-all,list,run,runpip,ensurepath,completions} ...

DESCRIPTION
Install and execute apps from Python packages.

Binaries can either be installed globally into isolated Virtual Environments
or run directly in a temporary Virtual Environment.

Virtual Environment location is ~/.local/pipx/venvs.
Symlinks to apps are placed in ~/.local/bin.

optional environment variables:
  PIPX_HOME Overrides default pipx location. Virtual Environments
                        will be installed to $PIPX_HOME/venvs.
  PIPX_BIN_DIR Overrides location of app installations. Apps are
                        symlinked or copied here.
  USE_EMOJI Overrides emoji behavior. Default value varies based
                        on platform.
  PIPX_DEFAULT_PYTHON Overrides default python used for commands.

OPTIONS

--version
    Print version and exit

  Sub-commands

pipx install
    Install a package

pipx inject
    Install packages into an existing Virtual Environment

pipx upgrade
    Upgrade a package

pipx upgrade-all
    Upgrade all packages. Runs `pip install -U <pkgname>` for each package.

pipx uninstall
    Uninstall a package

pipx uninstall-all
    Uninstall all packages

pipx reinstall
    Reinstall a package

pipx reinstall-all
    Reinstall all packages

pipx list
    List installed packages

pipx run
    Download the latest version of a package to a temporary virtual environment, then run an app from it. Also compatible with local `__pypackages__` directory (experimental).

pipx runpip
    Run pip in an existing pipx-managed Virtual Environment

pipx ensurepath
    Ensure directories necessary for pipx operation are in your PATH environment variable.

pipx completions
    Print instructions on enabling shell completions for pipx

OPTIONS 'pipx install'
usage: pipx install [-h] [--include-deps] [--verbose] [--force]
                    [--suffix SUFFIX] [--python PYTHON]
                    [--system-site-packages] [--index-url INDEX_URL]
                    [--editable] [--pip-args PIP_ARGS]
                    package_spec

The install command is the preferred way to globally install apps
from python packages on your system. It creates an isolated virtual
environment for the package, then ensures the package's apps are
accessible on your $PATH.

The result: apps you can run from anywhere, located in packages
you can cleanly upgrade or uninstall. Guaranteed to not have
dependency version conflicts or interfere with your OS's python
packages. 'sudo' is not required to do this.

pipx install PACKAGE_NAME
pipx install --python PYTHON PACKAGE_NAME
pipx install VCS_URL
pipx install ./LOCAL_PATH
pipx install ZIP_FILE
pipx install TAR_GZ_FILE

The PACKAGE_SPEC argument is passed directly to `pip install`.

The default virtual environment location is ~/.local/pipx
and can be overridden by setting the environment variable `PIPX_HOME`
(Virtual Environments will be installed to `$PIPX_HOME/venvs`).

The default app location is ~/.local/bin and can be
overridden by setting the environment variable `PIPX_BIN_DIR`.

The default python executable used to install a package is
/usr/bin/python3 and can be overridden
by setting the environment variable `PIPX_DEFAULT_PYTHON`.

package_spec
    package name or pip installation spec

--include-deps
    Include apps of dependent packages

--verbose

--force, -f
    Modify existing virtual environment and files in PIPX_BIN_DIR

--suffix SUFFIX
    Optional suffix for virtual environment and executable names. NOTE: The suffix feature is experimental and subject to change.

--python PYTHON
    The Python executable used to create the Virtual Environment and run the associated app/apps. Must be v3.6+.

--system-site-packages
    Give the virtual environment access to the system site-packages dir.

--index-url INDEX_URL, -i INDEX_URL
    Base URL of Python Package Index

--editable, -e
    Install a project in editable mode

--pip-args PIP_ARGS
    Arbitrary pip arguments to pass directly to pip install/upgrade commands

OPTIONS 'pipx inject'
usage: pipx inject [-h] [--include-apps] [--include-deps]
                   [--system-site-packages] [--index-url INDEX_URL]
                   [--editable] [--pip-args PIP_ARGS] [--force] [--verbose]
                   package dependencies [dependencies ...]

Installs packages to an existing pipx-managed virtual environment.

package
    Name of the existing pipx-managed Virtual Environment to inject into

dependencies
    the packages to inject into the Virtual Environment--either package name or pip package spec

--include-apps
    Add apps from the injected packages onto your PATH

--include-deps
    Include apps of dependent packages

--system-site-packages
    Give the virtual environment access to the system site-packages dir.

--index-url INDEX_URL, -i INDEX_URL
    Base URL of Python Package Index

--editable, -e
    Install a project in editable mode

--pip-args PIP_ARGS
    Arbitrary pip arguments to pass directly to pip install/upgrade commands

--force, -f
    Modify existing virtual environment and files in PIPX_BIN_DIR

--verbose

OPTIONS 'pipx upgrade'
usage: pipx upgrade [-h] [--include-injected] [--force]
                    [--system-site-packages] [--index-url INDEX_URL]
                    [--editable] [--pip-args PIP_ARGS] [--verbose]
                    package

Upgrade a package in a pipx-managed Virtual Environment by running 'pip install --upgrade PACKAGE'

package

--include-injected
    Also upgrade packages injected into the main app's environment

--force, -f
    Modify existing virtual environment and files in PIPX_BIN_DIR

--system-site-packages
    Give the virtual environment access to the system site-packages dir.

--index-url INDEX_URL, -i INDEX_URL
    Base URL of Python Package Index

--editable, -e
    Install a project in editable mode

--pip-args PIP_ARGS
    Arbitrary pip arguments to pass directly to pip install/upgrade commands

--verbose

OPTIONS 'pipx upgrade-all'
usage: pipx upgrade-all [-h] [--include-injected] [--skip SKIP [SKIP ...]]
                        [--force] [--verbose]

Upgrades all packages within their virtual environments by running 'pip install --upgrade PACKAGE'

--include-injected
    Also upgrade packages injected into the main app's environment

--skip SKIP [SKIP ...]
    skip these packages

--force, -f
    Modify existing virtual environment and files in PIPX_BIN_DIR

--verbose

OPTIONS 'pipx uninstall'
usage: pipx uninstall [-h] [--verbose] package

Uninstalls a pipx-managed Virtual Environment by deleting it and any files that point to its apps.

package

--verbose

OPTIONS 'pipx uninstall-all'
usage: pipx uninstall-all [-h] [--verbose]

Uninstall all pipx-managed packages

--verbose

OPTIONS 'pipx reinstall'
usage: pipx reinstall [-h] [--python PYTHON] [--verbose] package

Reinstalls a package.

Package is uninstalled, then installed with pipx install PACKAGE
with the same options used in the original install of PACKAGE.

package

--python PYTHON
    The Python executable used to recreate the Virtual Environment and run the associated app/apps. Must be v3.6+.

--verbose

OPTIONS 'pipx reinstall-all'
usage: pipx reinstall-all [-h] [--python PYTHON] [--skip SKIP [SKIP ...]]
                        [--verbose]

Reinstalls all packages.

Packages are uninstalled, then installed with pipx install PACKAGE
with the same options used in the original install of PACKAGE.
This is useful if you upgraded to a new version of Python and want
all your packages to use the latest as well.

--python PYTHON
    The Python executable used to recreate the Virtual Environment and run the associated app/apps. Must be v3.6+.

--skip SKIP [SKIP ...]
    skip these packages

--verbose

OPTIONS 'pipx list'
usage: pipx list [-h] [--include-injected] [--json] [--verbose]

List packages and apps installed with pipx

--include-injected
    Show packages injected into the main app's environment

--json
    Output rich data in json format.

--verbose

OPTIONS 'pipx run'
usage: pipx run [-h] [--no-cache] [--pypackages] [--spec SPEC] [--verbose]
                [--python PYTHON] [--system-site-packages]
                [--index-url INDEX_URL] [--editable] [--pip-args PIP_ARGS]
                app ...

Download the latest version of a package to a temporary virtual environment,
then run an app from it. The environment will be cached
and re-used for up to 14 days. This
means subsequent calls to 'run' for the same package will be faster
since they can re-use the cached Virtual Environment.

In support of PEP 582 'run' will use apps found in a local __pypackages__
directory, if present. Please note that this behavior is experimental,
and acts as a companion tool to pythonloc. It may be modified or
removed in the future. See https://github.com/cs01/pythonloc.

app ...
    app/package name and any arguments to be passed to it

--no-cache
    Do not re-use cached virtual environment if it exists

--pypackages
    Require app to be run from local __pypackages__ directory

--spec SPEC
    The package name or specific installation source passed to pip.
    Runs `pip install -U SPEC`.
    For example `--spec mypackage==2.0.0` or `--spec git+https://github.com/user/repo.git@branch`

--verbose

--python PYTHON
    The Python version to run package's CLI app with. Must be v3.6+.

--system-site-packages
    Give the virtual environment access to the system site-packages dir.

--index-url INDEX_URL, -i INDEX_URL
    Base URL of Python Package Index

--editable, -e
    Install a project in editable mode

--pip-args PIP_ARGS
    Arbitrary pip arguments to pass directly to pip install/upgrade commands

OPTIONS 'pipx runpip'
usage: pipx runpip [-h] [--verbose] package ...

Run pip in an existing pipx-managed Virtual Environment

package
    Name of the existing pipx-managed Virtual Environment to run pip in

pipargs
    Arguments to forward to pip command

--verbose

OPTIONS 'pipx ensurepath'
usage: pipx ensurepath [-h] [--force]

Ensure directory where pipx stores apps is in your PATH environment variable. Also if pipx was installed via `pip install --user`, ensure pipx itself is in your PATH. Note that running this may modify your shell's configuration file(s) such as '~/.bashrc'.

--force, -f
    Add text to your shell's config file even if it looks like your PATH already contains paths to pipx and pipx-install apps.

OPTIONS 'pipx completions'
usage: pipx completions [-h]

Print instructions on enabling shell completions for pipx

AUTHORS
pipx(1) was written by Chad Smith and contributors. The project can be found online at https://pypa.github.io/pipx/

SEE ALSO
pip(1), virtualenv(1)